"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createEditor;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _codemirror = _interopRequireDefault(require("codemirror"));

require("codemirror/mode/javascript/javascript");

require("codemirror/mode/htmlmixed/htmlmixed");

require("codemirror/mode/markdown/markdown");

require("codemirror/addon/display/autorefresh");

require("codemirror/addon/display/fullscreen");

require("codemirror/addon/selection/active-line");

require("codemirror/addon/fold/foldcode");

require("codemirror/addon/fold/foldgutter");

require("codemirror/addon/fold/brace-fold");

require("codemirror/addon/fold/indent-fold");

require("codemirror/addon/edit/matchbrackets");

require("codemirror/addon/edit/closebrackets");

require("codemirror/addon/edit/closetag");

require("codemirror/addon/dialog/dialog");

require("codemirror/addon/search/search");

require("codemirror/addon/search/searchcursor");

require("codemirror/addon/search/jump-to-line");

require("codemirror/addon/search/matchesonscrollbar");

require("codemirror/addon/lint/lint");

require("../addon/lint/json");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function createEditor(div, value) {
  var _conf$theme;

  var conf = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return (0, _codemirror.default)(div, _objectSpread({
    value: value,
    mode: 'text/plain',
    // 支持的 mode 可以查看 mode 模块的末尾
    // display
    theme: (_conf$theme = conf.theme) !== null && _conf$theme !== void 0 ? _conf$theme : conf.readOnly ? 'mdn-like' : 'oceanic-next',
    // 额外的 theme 要应用自行安装
    indentUnit: 2,
    lineNumbers: true,
    lineWrapping: true,
    styleActiveLine: !conf.readOnly,
    gutters: ['CodeMirror-lint-markers', 'CodeMirror-linenumbers', 'CodeMirror-foldgutter'],
    foldGutter: true,
    matchBrackets: true,
    // ease
    fullScreen: false,
    autoRefresh: true,
    autoCloseBrackets: '()[]{}\'\'""',
    autoCloseTags: true,
    // others
    lint: !conf.readOnly,
    extraKeys: {
      Tab: false
    }
  }, conf));
}